﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Drawing.Imaging;
using System.Runtime.InteropServices;

using Microsoft.Kinect;
namespace personmask
{
    public partial class Form1 : Form
    {
        KinectSensor sensor;

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            sensor = KinectSensor.KinectSensors[0];
            sensor.ColorStream.Enable(ColorImageFormat.RgbResolution640x480Fps30);
            sensor.DepthStream.Enable(DepthImageFormat.Resolution320x240Fps30);
            sensor.SkeletonStream.Enable();

            sensor.AllFramesReady += FramesReady;
            sensor.Start();

        }



        void FramesReady(object sender, AllFramesReadyEventArgs e)
        {

            DepthImageFrame DFrame = e.OpenDepthImageFrame();
            if (DFrame == null) return;
            short[] depthimage = new short[DFrame.PixelDataLength];
            DFrame.CopyPixelDataTo(depthimage);

            ColorImageFrame VFrame = e.OpenColorImageFrame();
            if (VFrame == null) return;
            byte[] pixeldata = new byte[VFrame.PixelDataLength];
            VFrame.CopyPixelDataTo(pixeldata);

            byte player;
            int vx, vy;

            for (int y = 0; y < DFrame.Height; y++)
            {
                for (int x = 0; x < DFrame.Width; x++)
                {
                    player = (byte)(depthimage[x + y * DFrame.Width] & DepthImageFrame.PlayerIndexBitmask);
                    if (player != 0) player = 0xFF;

                    vx = x * 2;
                    vy = y * 2;
                    //remove comments to see coordinate transformation in action
                    //ColorImagePoint p = DFrame.MapToColorImagePoint(x, y, ColorImageFormat.RgbResolution640x480Fps30);
                    //vx = p.X;
                    //vy = p.Y;
                    //vx = Math.Max(0, Math.Min(vx, VFrame.Width - 2));
                    //vy = Math.Max(0, Math.Min(vy, VFrame.Height - 2));
                    //
                    for (int k = 0; k < 8; k++)
                    {
                        pixeldata[(vx + vy * VFrame.Width) * VFrame.BytesPerPixel + k] &= player;
                        pixeldata[(vx + (vy + 1) * VFrame.Width) * VFrame.BytesPerPixel + k] &= player;

                    }
                }

            }
            pictureBox1.Image = ByteToBitmap(pixeldata, VFrame.Width, VFrame.Height);
        }

        Bitmap ByteToBitmap(Byte[] pixeldata, int w, int h)
        {
            Bitmap bmap = new Bitmap(w, h, PixelFormat.Format32bppRgb);
            BitmapData bmapdata = bmap.LockBits(
              new Rectangle(0, 0, w, h),
              ImageLockMode.WriteOnly,
              bmap.PixelFormat);
            IntPtr ptr = bmapdata.Scan0;
            Marshal.Copy(pixeldata, 0, ptr, pixeldata.Length);
            bmap.UnlockBits(bmapdata);
            return bmap;
        }

        private void Form1_FormClosing(
             object sender,
             FormClosingEventArgs e)
        {
            sensor.Stop();
        }


    }

}
